static const char *RcsId     = "$Header: /home/cvsadm/cvsroot/fermi/servers/fug_elettra/src/FugClass.cpp,v 1.1.1.1 2014-10-22 10:12:39 giulio Exp $";
static const char *TagName   = "$Name:  $";
static const char *HttpServer= "http://www.esrf.fr/computing/cs/tango/tango_doc/ds_doc/";
//+=============================================================================
//
// file :        FugClass.cpp
//
// description : C++ source for the FugClass. A singleton
//               class derived from DeviceClass. It implements the
//               command list and all properties and methods required
//               by the Fug once per process.
//
// project :     TANGO Device Server
//
// $Author: giulio $
//
// $Revision: 1.1.1.1 $
//
// $Log: FugClass.cpp,v $
// Revision 1.1.1.1  2014-10-22 10:12:39  giulio
// First cvs release
//
//
// copyleft :   Sincrotrone Trieste S.C.p.A.
//              Strada Statale 14 - km 163,5 in AREA Science Park
//              34012 Basovizza (TS)
//              ITALY
//
//-=============================================================================
//
//  		This file is generated by POGO
//	(Program Obviously used to Generate tango Object)
//
//         (c) - Software Engineering Group - ESRF 
//=============================================================================


#include <tango.h>

#include <Fug.h>
#include <FugClass.h>


//+----------------------------------------------------------------------------
/**
 *	Create FugClass singleton and return it in a C function for Python usage
 */
//+----------------------------------------------------------------------------
extern "C" {
#ifdef WIN32

__declspec(dllexport)

#endif

	Tango::DeviceClass *_create_Fug_class(const char *name) {
		return Fug_ns::FugClass::init(name);
	}
}


namespace Fug_ns
{

//+----------------------------------------------------------------------------
//
// method : 		OnClass::execute()
// 
// description : 	method to trigger the execution of the command.
//                PLEASE DO NOT MODIFY this method core without pogo   
//
// in : - device : The device on which the command must be excuted
//		- in_any : The command input data
//
// returns : The command output data (packed in the Any object)
//
//-----------------------------------------------------------------------------
CORBA::Any *OnClass::execute(Tango::DeviceImpl *device,const CORBA::Any &in_any)
{

	cout2 << "OnClass::execute(): arrived" << endl;

	((static_cast<Fug *>(device))->on());
	return new CORBA::Any();
}

//+----------------------------------------------------------------------------
//
// method : 		OffClass::execute()
// 
// description : 	method to trigger the execution of the command.
//                PLEASE DO NOT MODIFY this method core without pogo   
//
// in : - device : The device on which the command must be excuted
//		- in_any : The command input data
//
// returns : The command output data (packed in the Any object)
//
//-----------------------------------------------------------------------------
CORBA::Any *OffClass::execute(Tango::DeviceImpl *device,const CORBA::Any &in_any)
{

	cout2 << "OffClass::execute(): arrived" << endl;

	((static_cast<Fug *>(device))->off());
	return new CORBA::Any();
}

//+----------------------------------------------------------------------------
//
// method : 		SetIntegrationTimeClass::execute()
// 
// description : 	method to trigger the execution of the command.
//                PLEASE DO NOT MODIFY this method core without pogo   
//
// in : - device : The device on which the command must be excuted
//		- in_any : The command input data
//
// returns : The command output data (packed in the Any object)
//
//-----------------------------------------------------------------------------
CORBA::Any *SetIntegrationTimeClass::execute(Tango::DeviceImpl *device,const CORBA::Any &in_any)
{

	cout2 << "SetIntegrationTimeClass::execute(): arrived" << endl;

	Tango::DevLong	argin;
	extract(in_any, argin);

	((static_cast<Fug *>(device))->set_integration_time(argin));
	return new CORBA::Any();
}

//+----------------------------------------------------------------------------
//
// method : 		GetIntegrationTimeClass::execute()
// 
// description : 	method to trigger the execution of the command.
//                PLEASE DO NOT MODIFY this method core without pogo   
//
// in : - device : The device on which the command must be excuted
//		- in_any : The command input data
//
// returns : The command output data (packed in the Any object)
//
//-----------------------------------------------------------------------------
CORBA::Any *GetIntegrationTimeClass::execute(Tango::DeviceImpl *device,const CORBA::Any &in_any)
{

	cout2 << "GetIntegrationTimeClass::execute(): arrived" << endl;

	return insert((static_cast<Fug *>(device))->get_integration_time());
}


//
//----------------------------------------------------------------
//	Initialize pointer for singleton pattern
//----------------------------------------------------------------
//
FugClass *FugClass::_instance = NULL;

//+----------------------------------------------------------------------------
//
// method : 		FugClass::FugClass(string &s)
// 
// description : 	constructor for the FugClass
//
// in : - s : The class name
//
//-----------------------------------------------------------------------------
FugClass::FugClass(string &s):DeviceClass(s)
{

	cout2 << "Entering FugClass constructor" << endl;
	set_default_property();
	write_class_property();
	get_class_property();
	
	cout2 << "Leaving FugClass constructor" << endl;

}
//+----------------------------------------------------------------------------
//
// method : 		FugClass::~FugClass()
// 
// description : 	destructor for the FugClass
//
//-----------------------------------------------------------------------------
FugClass::~FugClass()
{
	_instance = NULL;
}

//+----------------------------------------------------------------------------
//
// method : 		FugClass::instance
// 
// description : 	Create the object if not already done. Otherwise, just
//			return a pointer to the object
//
// in : - name : The class name
//
//-----------------------------------------------------------------------------
FugClass *FugClass::init(const char *name)
{
	if (_instance == NULL)
	{
		try
		{
			string s(name);
			_instance = new FugClass(s);
		}
		catch (bad_alloc)
		{
			throw;
		}		
	}		
	return _instance;
}

FugClass *FugClass::instance()
{
	if (_instance == NULL)
	{
		cerr << "Class is not initialised !!" << endl;
		exit(-1);
	}
	return _instance;
}

//+----------------------------------------------------------------------------
//
// method : 		FugClass::command_factory
// 
// description : 	Create the command object(s) and store them in the 
//			command list
//
//-----------------------------------------------------------------------------
void FugClass::command_factory()
{
	command_list.push_back(new OnClass("On",
		Tango::DEV_VOID, Tango::DEV_VOID,
		"",
		"",
		Tango::OPERATOR));
	command_list.push_back(new OffClass("Off",
		Tango::DEV_VOID, Tango::DEV_VOID,
		"",
		"",
		Tango::OPERATOR));
	command_list.push_back(new SetIntegrationTimeClass("SetIntegrationTime",
		Tango::DEV_LONG, Tango::DEV_VOID,
		"",
		"",
		Tango::OPERATOR));
	command_list.push_back(new GetIntegrationTimeClass("GetIntegrationTime",
		Tango::DEV_VOID, Tango::DEV_LONG,
		"",
		"",
		Tango::OPERATOR));

	//	add polling if any
	for (unsigned int i=0 ; i<command_list.size(); i++)
	{
	}
}

//+----------------------------------------------------------------------------
//
// method : 		FugClass::get_class_property
// 
// description : 	Get the class property for specified name.
//
// in :		string	name : The property name
//
//+----------------------------------------------------------------------------
Tango::DbDatum FugClass::get_class_property(string &prop_name)
{
	for (int i=0 ; i<cl_prop.size() ; i++)
		if (cl_prop[i].name == prop_name)
			return cl_prop[i];
	//	if not found, return  an empty DbDatum
	return Tango::DbDatum(prop_name);
}
//+----------------------------------------------------------------------------
//
// method : 		FugClass::get_default_device_property()
// 
// description : 	Return the default value for device property.
//
//-----------------------------------------------------------------------------
Tango::DbDatum FugClass::get_default_device_property(string &prop_name)
{
	for (int i=0 ; i<dev_def_prop.size() ; i++)
		if (dev_def_prop[i].name == prop_name)
			return dev_def_prop[i];
	//	if not found, return  an empty DbDatum
	return Tango::DbDatum(prop_name);
}

//+----------------------------------------------------------------------------
//
// method : 		FugClass::get_default_class_property()
// 
// description : 	Return the default value for class property.
//
//-----------------------------------------------------------------------------
Tango::DbDatum FugClass::get_default_class_property(string &prop_name)
{
	for (int i=0 ; i<cl_def_prop.size() ; i++)
		if (cl_def_prop[i].name == prop_name)
			return cl_def_prop[i];
	//	if not found, return  an empty DbDatum
	return Tango::DbDatum(prop_name);
}
//+----------------------------------------------------------------------------
//
// method : 		FugClass::device_factory
// 
// description : 	Create the device object(s) and store them in the 
//			device list
//
// in :		Tango::DevVarStringArray *devlist_ptr : The device name list
//
//-----------------------------------------------------------------------------
void FugClass::device_factory(const Tango::DevVarStringArray *devlist_ptr)
{

	//	Create all devices.(Automatic code generation)
	//-------------------------------------------------------------
	for (unsigned long i=0 ; i < devlist_ptr->length() ; i++)
	{
		cout4 << "Device name : " << (*devlist_ptr)[i].in() << endl;
						
		// Create devices and add it into the device list
		//----------------------------------------------------
		device_list.push_back(new Fug(this, (*devlist_ptr)[i]));							 

		// Export device to the outside world
		// Check before if database used.
		//---------------------------------------------
		if ((Tango::Util::_UseDb == true) && (Tango::Util::_FileDb == false))
			export_device(device_list.back());
		else
			export_device(device_list.back(), (*devlist_ptr)[i]);
	}
	//	End of Automatic code generation
	//-------------------------------------------------------------

}
//+----------------------------------------------------------------------------
//	Method: FugClass::attribute_factory(vector<Tango::Attr *> &att_list)
//-----------------------------------------------------------------------------
void FugClass::attribute_factory(vector<Tango::Attr *> &att_list)
{
	//	Attribute : Voltage
	VoltageAttrib	*voltage = new VoltageAttrib();
	Tango::UserDefaultAttrProp	voltage_prop;
	voltage_prop.set_label("Voltage");
	voltage_prop.set_unit("KVolt");
	voltage_prop.set_standard_unit("1000");
	voltage_prop.set_display_unit("KVolt");
	voltage_prop.set_format("%2.3f");
	voltage_prop.set_description("Actual measured voltage.");
	voltage->set_default_properties(voltage_prop);
	att_list.push_back(voltage);

	//	Attribute : Current
	CurrentAttrib	*current = new CurrentAttrib();
	Tango::UserDefaultAttrProp	current_prop;
	current_prop.set_label("Current");
	current_prop.set_unit("A");
	current_prop.set_standard_unit("1");
	current_prop.set_display_unit("A");
	current_prop.set_format("%1.4f");
	current_prop.set_description("Actual measured current.");
	current->set_default_properties(current_prop);
	att_list.push_back(current);

	//	Attribute : VoltageSet
	VoltageSetAttrib	*voltage_set = new VoltageSetAttrib();
	Tango::UserDefaultAttrProp	voltage_set_prop;
	voltage_set_prop.set_label("VoltageSet");
	voltage_set_prop.set_unit("KVolt");
	voltage_set_prop.set_standard_unit("1000");
	voltage_set_prop.set_display_unit("KVolt");
	voltage_set_prop.set_format("%2.3f");
	voltage_set_prop.set_description("This is the voltage setting of the Fug.Some Fug versions\ndoesn't support this query.\nIn this case last setting is stored in lastvoltset device property");
	voltage_set->set_default_properties(voltage_set_prop);
	att_list.push_back(voltage_set);

	//	Attribute : CurrentSet
	CurrentSetAttrib	*current_set = new CurrentSetAttrib();
	Tango::UserDefaultAttrProp	current_set_prop;
	current_set_prop.set_label("CurrentSet");
	current_set_prop.set_unit("A");
	current_set_prop.set_standard_unit("1");
	current_set_prop.set_display_unit("A");
	current_set_prop.set_format("%1.4f");
	current_set_prop.set_description("This is the current charge soil setting of the Fug.Some Fug verisions\ndoesn't support this query.\nIn this case last setting is stored in last curset device property");
	current_set->set_default_properties(current_set_prop);
	att_list.push_back(current_set);

	//	Attribute : Stat
	StatAttrib	*stat = new StatAttrib();
	Tango::UserDefaultAttrProp	stat_prop;
	stat_prop.set_label("Status");
	stat_prop.set_description("bit0: 1=Current control active, bit1: 1=Voltage control active, bit2:1=Output voltage is switched on, bit3: 1=Command error, bit4: 1=Range violation");
	stat->set_default_properties(stat_prop);
	att_list.push_back(stat);

	//	Attribute : MaxDiffVoltage
	MaxDiffVoltageAttrib	*max_diff_voltage = new MaxDiffVoltageAttrib();
	Tango::UserDefaultAttrProp	max_diff_voltage_prop;
	max_diff_voltage_prop.set_label("MaxDiffVoltage");
	max_diff_voltage_prop.set_unit("KVolt");
	max_diff_voltage_prop.set_standard_unit("1000");
	max_diff_voltage_prop.set_display_unit("KVolt");
	max_diff_voltage_prop.set_format("%2.3f");
	max_diff_voltage_prop.set_description("Actual measured voltage.");
	max_diff_voltage->set_default_properties(max_diff_voltage_prop);
	att_list.push_back(max_diff_voltage);

}

//+----------------------------------------------------------------------------
//
// method : 		FugClass::get_class_property()
// 
// description : 	Read the class properties from database.
//
//-----------------------------------------------------------------------------
void FugClass::get_class_property()
{
	//	Initialize your default values here (if not done with  POGO).
	//------------------------------------------------------------------

	//	Read class properties from database.(Automatic code generation)
	//------------------------------------------------------------------

	//	Call database and extract values
	//--------------------------------------------
	if (Tango::Util::instance()->_UseDb==true)
		get_db_class()->get_property(cl_prop);
	Tango::DbDatum	def_prop;
	int	i = -1;


	//	End of Automatic code generation
	//------------------------------------------------------------------

}

//+----------------------------------------------------------------------------
//
// method : 	FugClass::set_default_property
// 
// description: Set default property (class and device) for wizard.
//              For each property, add to wizard property name and description
//              If default value has been set, add it to wizard property and
//              store it in a DbDatum.
//
//-----------------------------------------------------------------------------
void FugClass::set_default_property()
{
	string	prop_name;
	string	prop_desc;
	string	prop_def;

	vector<string>	vect_data;
	//	Set Default Class Properties
	//	Set Default Device Properties
	prop_name = "Serialdevice";
	prop_desc = "name of the serialline device server";
	prop_def  = "";
	if (prop_def.length()>0)
	{
		Tango::DbDatum	data(prop_name);
		data << vect_data ;
		dev_def_prop.push_back(data);
		add_wiz_dev_prop(prop_name, prop_desc,  prop_def);
	}
	else
		add_wiz_dev_prop(prop_name, prop_desc);

	prop_name = "Maxvoltage";
	prop_desc = "Maximum voltage value [Volt]";
	prop_def  = "60";
	vect_data.clear();
	vect_data.push_back("60");
	if (prop_def.length()>0)
	{
		Tango::DbDatum	data(prop_name);
		data << vect_data ;
		dev_def_prop.push_back(data);
		add_wiz_dev_prop(prop_name, prop_desc,  prop_def);
	}
	else
		add_wiz_dev_prop(prop_name, prop_desc);

	prop_name = "Maxcurrent";
	prop_desc = "Maximum current value [Ampere].";
	prop_def  = "5";
	vect_data.clear();
	vect_data.push_back("5");
	if (prop_def.length()>0)
	{
		Tango::DbDatum	data(prop_name);
		data << vect_data ;
		dev_def_prop.push_back(data);
		add_wiz_dev_prop(prop_name, prop_desc,  prop_def);
	}
	else
		add_wiz_dev_prop(prop_name, prop_desc);

	prop_name = "Sleeptime";
	prop_desc = "Sleeptime after any read or write action on serialline device in milliseconds.";
	prop_def  = "200";
	vect_data.clear();
	vect_data.push_back("200");
	if (prop_def.length()>0)
	{
		Tango::DbDatum	data(prop_name);
		data << vect_data ;
		dev_def_prop.push_back(data);
		add_wiz_dev_prop(prop_name, prop_desc,  prop_def);
	}
	else
		add_wiz_dev_prop(prop_name, prop_desc);

	prop_name = "Readback";
	prop_desc = "It is true if Fug supports readback of the voltage and current settings,\notherwise false";
	prop_def  = "false";
	vect_data.clear();
	vect_data.push_back("false");
	if (prop_def.length()>0)
	{
		Tango::DbDatum	data(prop_name);
		data << vect_data ;
		dev_def_prop.push_back(data);
		add_wiz_dev_prop(prop_name, prop_desc,  prop_def);
	}
	else
		add_wiz_dev_prop(prop_name, prop_desc);

	prop_name = "Pausetime";
	prop_desc = "Millisecond between each call in readloop thread";
	prop_def  = "200";
	vect_data.clear();
	vect_data.push_back("200");
	if (prop_def.length()>0)
	{
		Tango::DbDatum	data(prop_name);
		data << vect_data ;
		dev_def_prop.push_back(data);
		add_wiz_dev_prop(prop_name, prop_desc,  prop_def);
	}
	else
		add_wiz_dev_prop(prop_name, prop_desc);

	prop_name = "StringTerminator";
	prop_desc = "Serial string terminator:\n13=old probus 3 fug serial controller\n10=new probus 5 fug serial controller";
	prop_def  = "13";
	vect_data.clear();
	vect_data.push_back("13");
	if (prop_def.length()>0)
	{
		Tango::DbDatum	data(prop_name);
		data << vect_data ;
		dev_def_prop.push_back(data);
		add_wiz_dev_prop(prop_name, prop_desc,  prop_def);
	}
	else
		add_wiz_dev_prop(prop_name, prop_desc);

	prop_name = "MaxDiffLen";
	prop_desc = "";
	prop_def  = "20";
	vect_data.clear();
	vect_data.push_back("20");
	if (prop_def.length()>0)
	{
		Tango::DbDatum	data(prop_name);
		data << vect_data ;
		dev_def_prop.push_back(data);
		add_wiz_dev_prop(prop_name, prop_desc,  prop_def);
	}
	else
		add_wiz_dev_prop(prop_name, prop_desc);

}
//+----------------------------------------------------------------------------
//
// method : 		FugClass::write_class_property
// 
// description : 	Set class description as property in database
//
//-----------------------------------------------------------------------------
void FugClass::write_class_property()
{
	//	First time, check if database used
	//--------------------------------------------
	if (Tango::Util::_UseDb == false)
		return;

	Tango::DbData	data;
	string	classname = get_name();
	string	header;
	string::size_type	start, end;

	//	Put title
	Tango::DbDatum	title("ProjectTitle");
	string	str_title("FuG HV power supply device server");
	title << str_title;
	data.push_back(title);

	//	Put Description
	Tango::DbDatum	description("Description");
	vector<string>	str_desc;
	str_desc.push_back("This is FuG HV power supply device server.");
	str_desc.push_back("It supports the original version of FuG RS-232 interface: no reading of the");
	str_desc.push_back("setting.");
	description << str_desc;
	data.push_back(description);
		
	//	put cvs location
	string	rcsId(RcsId);
	string	filename(classname);
	start = rcsId.find("/");
	if (start!=string::npos)
	{
		filename += "Class.cpp";
		end   = rcsId.find(filename);
		if (end>start)
		{
			string	strloc = rcsId.substr(start, end-start);
			//	Check if specific repository
			start = strloc.find("/cvsroot/");
			if (start!=string::npos && start>0)
			{
				string	repository = strloc.substr(0, start);
				if (repository.find("/segfs/")!=string::npos)
					strloc = "ESRF:" + strloc.substr(start, strloc.length()-start);
			}
			Tango::DbDatum	cvs_loc("cvs_location");
			cvs_loc << strloc;
			data.push_back(cvs_loc);
		}
	}

	//	Get CVS tag revision
	string	tagname(TagName);
	header = "$Name: ";
	start = header.length();
	string	endstr(" $");
	end   = tagname.find(endstr);
	if (end!=string::npos && end>start)
	{
		string	strtag = tagname.substr(start, end-start);
		Tango::DbDatum	cvs_tag("cvs_tag");
		cvs_tag << strtag;
		data.push_back(cvs_tag);
	}

	//	Get URL location
	string	httpServ(HttpServer);
	if (httpServ.length()>0)
	{
		Tango::DbDatum	db_doc_url("doc_url");
		db_doc_url << httpServ;
		data.push_back(db_doc_url);
	}

	//  Put inheritance
	Tango::DbDatum	inher_datum("InheritedFrom");
	vector<string> inheritance;
	inheritance.push_back("TANGO_BASE_CLASS");
	inher_datum << inheritance;
	data.push_back(inher_datum);

	//	Call database and and values
	//--------------------------------------------
	get_db_class()->put_property(data);
}

}	// namespace
