//=============================================================================
//
// file :         FugClass.h
//
// description :  Include for the FugClass root class.
//                This class is represents the singleton class for
//                the Fug device class.
//                It contains all properties and methods which the 
//                Fug requires only once e.g. the commands.
//			
// project :      TANGO Device Server
//
// $Author: giulio $
//
// $Revision: 1.1.1.1 $
//
// $Log: FugClass.h,v $
// Revision 1.1.1.1  2014-10-22 10:12:39  giulio
// First cvs release
//
//
// copyleft :   Sincrotrone Trieste S.C.p.A.
//              Strada Statale 14 - km 163,5 in AREA Science Park
//              34012 Basovizza (TS)
//              ITALY
//
//=============================================================================
//
//  		This file is generated by POGO
//	(Program Obviously used to Generate tango Object)
//
//         (c) - Software Engineering Group - ESRF 
//=============================================================================

#ifndef _FUGCLASS_H
#define _FUGCLASS_H

#include <tango.h>
#include <Fug.h>


namespace Fug_ns
{
//=====================================
//	Define classes for attributes
//=====================================
class MaxDiffVoltageAttrib: public Tango::Attr
{
public:
	MaxDiffVoltageAttrib():Attr("MaxDiffVoltage", Tango::DEV_DOUBLE, Tango::READ) {};
	~MaxDiffVoltageAttrib() {};
	
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
	{(static_cast<Fug *>(dev))->read_MaxDiffVoltage(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
	{return (static_cast<Fug *>(dev))->is_MaxDiffVoltage_allowed(ty);}
};

class StatAttrib: public Tango::SpectrumAttr
{
public:
	StatAttrib():SpectrumAttr("Stat", Tango::DEV_BOOLEAN, Tango::READ, 5) {};
	~StatAttrib() {};
	
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
	{(static_cast<Fug *>(dev))->read_Stat(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
	{return (static_cast<Fug *>(dev))->is_Stat_allowed(ty);}
};

class CurrentSetAttrib: public Tango::Attr
{
public:
	CurrentSetAttrib():Attr("CurrentSet", Tango::DEV_DOUBLE, Tango::READ) {};
	~CurrentSetAttrib() {};
	
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
	{(static_cast<Fug *>(dev))->read_CurrentSet(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
	{return (static_cast<Fug *>(dev))->is_CurrentSet_allowed(ty);}
};

class VoltageSetAttrib: public Tango::Attr
{
public:
	VoltageSetAttrib():Attr("VoltageSet", Tango::DEV_DOUBLE, Tango::READ) {};
	~VoltageSetAttrib() {};
	
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
	{(static_cast<Fug *>(dev))->read_VoltageSet(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
	{return (static_cast<Fug *>(dev))->is_VoltageSet_allowed(ty);}
};

class CurrentAttrib: public Tango::Attr
{
public:
	CurrentAttrib():Attr("Current", Tango::DEV_DOUBLE, Tango::READ_WRITE) {};
	~CurrentAttrib() {};
	
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
	{(static_cast<Fug *>(dev))->read_Current(att);}
	virtual void write(Tango::DeviceImpl *dev,Tango::WAttribute &att)
	{(static_cast<Fug *>(dev))->write_Current(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
	{return (static_cast<Fug *>(dev))->is_Current_allowed(ty);}
};

class VoltageAttrib: public Tango::Attr
{
public:
	VoltageAttrib():Attr("Voltage", Tango::DEV_DOUBLE, Tango::READ_WRITE) {};
	~VoltageAttrib() {};
	
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
	{(static_cast<Fug *>(dev))->read_Voltage(att);}
	virtual void write(Tango::DeviceImpl *dev,Tango::WAttribute &att)
	{(static_cast<Fug *>(dev))->write_Voltage(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
	{return (static_cast<Fug *>(dev))->is_Voltage_allowed(ty);}
};

//=========================================
//	Define classes for commands
//=========================================
class GetIntegrationTimeClass : public Tango::Command
{
public:
	GetIntegrationTimeClass(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out,
				   const char        *in_desc,
				   const char        *out_desc,
				   Tango::DispLevel  level)
	:Command(name,in,out,in_desc,out_desc, level)	{};

	GetIntegrationTimeClass(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out)
	:Command(name,in,out)	{};
	~GetIntegrationTimeClass() {};
	
	virtual CORBA::Any *execute (Tango::DeviceImpl *dev, const CORBA::Any &any);
	virtual bool is_allowed (Tango::DeviceImpl *dev, const CORBA::Any &any)
	{return (static_cast<Fug *>(dev))->is_GetIntegrationTime_allowed(any);}
};



class SetIntegrationTimeClass : public Tango::Command
{
public:
	SetIntegrationTimeClass(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out,
				   const char        *in_desc,
				   const char        *out_desc,
				   Tango::DispLevel  level)
	:Command(name,in,out,in_desc,out_desc, level)	{};

	SetIntegrationTimeClass(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out)
	:Command(name,in,out)	{};
	~SetIntegrationTimeClass() {};
	
	virtual CORBA::Any *execute (Tango::DeviceImpl *dev, const CORBA::Any &any);
	virtual bool is_allowed (Tango::DeviceImpl *dev, const CORBA::Any &any)
	{return (static_cast<Fug *>(dev))->is_SetIntegrationTime_allowed(any);}
};



class OffClass : public Tango::Command
{
public:
	OffClass(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out,
				   const char        *in_desc,
				   const char        *out_desc,
				   Tango::DispLevel  level)
	:Command(name,in,out,in_desc,out_desc, level)	{};

	OffClass(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out)
	:Command(name,in,out)	{};
	~OffClass() {};
	
	virtual CORBA::Any *execute (Tango::DeviceImpl *dev, const CORBA::Any &any);
	virtual bool is_allowed (Tango::DeviceImpl *dev, const CORBA::Any &any)
	{return (static_cast<Fug *>(dev))->is_Off_allowed(any);}
};



class OnClass : public Tango::Command
{
public:
	OnClass(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out,
				   const char        *in_desc,
				   const char        *out_desc,
				   Tango::DispLevel  level)
	:Command(name,in,out,in_desc,out_desc, level)	{};

	OnClass(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out)
	:Command(name,in,out)	{};
	~OnClass() {};
	
	virtual CORBA::Any *execute (Tango::DeviceImpl *dev, const CORBA::Any &any);
	virtual bool is_allowed (Tango::DeviceImpl *dev, const CORBA::Any &any)
	{return (static_cast<Fug *>(dev))->is_On_allowed(any);}
};



//
// The FugClass singleton definition
//

class FugClass : public Tango::DeviceClass
{
public:
//	properties member data

//	add your own data members here
//------------------------------------

public:
	Tango::DbData	cl_prop;
	Tango::DbData	cl_def_prop;
	Tango::DbData	dev_def_prop;

//	Method prototypes
	static FugClass *init(const char *);
	static FugClass *instance();
	~FugClass();
	Tango::DbDatum	get_class_property(string &);
	Tango::DbDatum	get_default_device_property(string &);
	Tango::DbDatum	get_default_class_property(string &);
	
protected:
	FugClass(string &);
	static FugClass *_instance;
	void command_factory();
	void get_class_property();
	void attribute_factory(vector<Tango::Attr *> &);
	void write_class_property();
	void set_default_property();

private:
	void device_factory(const Tango::DevVarStringArray *);
};


}	//	namespace Fug_ns

#endif // _FUGCLASS_H
