//
// file :         fugthread.cpp
//
// description :  reading thread
//
// project :      TANGO Device Server
//
// $Author: giulio $ Giulio Gaio
//
// $Revision: 1.1.1.1 $ 1.0
//
// $Log: fugthread.cpp,v $
// Revision 1.1.1.1  2014-10-22 10:12:39  giulio
// First cvs release
//
//
// copyleft :   Sincrotrone Trieste S.C.p.A.
//              Strada Statale 14 - km 163,5 in AREA Science Park
//              34012 Basovizza, Trieste ITALY
//

#include "fugthread.h"
namespace Fug_ns
{
	
/* 
 *	fugthread::run()
 *	Run  
 */		
void fugthread::run(void *) 
{
	int pausesec;
	int pausenano;
	int pausesec_dfl;
	int pausenano_dfl;
	int cnt_err = 0;
	int max_cnt_err = 3;

	pausesec = pausesec_dfl = (int)myfug->pausetime/1000;
	pausenano = pausenano_dfl = (myfug->pausetime-pausesec*1000)*1000000;
	
	while (!myfug->abortflag) {	
		
		if (!myfug->abortflag) {
			myfug->mutex->lock();
			if (Voltage() < 0) 
				cnt_err++;
			else
				cnt_err = 0;	
			if (cnt_err > max_cnt_err) {
				pausesec = 1;
				pausenano = 0;
			}
			else {
				pausesec = pausesec_dfl;
				pausenano = pausenano_dfl;
			}
			myfug->mutex->unlock();
			omni_thread::sleep(pausesec,pausenano);	
		}
		
		if (!myfug->abortflag) {
			myfug->mutex->lock();
			if (Current() < 0) 
				cnt_err++;
			else
				cnt_err = 0;	
			if (cnt_err > max_cnt_err) {
				pausesec = 1;
				pausenano = 0;
			}
			else {
				pausesec = pausesec_dfl;
				pausenano = pausenano_dfl;
			}
			myfug->mutex->unlock();
			omni_thread::sleep(pausesec,pausenano);		
		}
		
		if (!myfug->abortflag) {
			myfug->mutex->lock();
			if (Stat() < 0) 			
				cnt_err++;
			else
				cnt_err = 0;	

			if (cnt_err > max_cnt_err) {
				pausesec = 1;
				pausenano = 0;
			}
			else {
				pausesec = pausesec_dfl;
				pausenano = pausenano_dfl;
			}		
			myfug->mutex->unlock();
			omni_thread::sleep(pausesec,pausenano);					
		}

		if (myfug->readback == true) {

			if (!myfug->abortflag) {
				myfug->mutex->lock();
				if (Voltage() < 0) 
					cnt_err++;
				else
					cnt_err = 0;	
				if (cnt_err > max_cnt_err) {
					pausesec = 1;
					pausenano = 0;
				}
				else {
					pausesec = pausesec_dfl;
					pausenano = pausenano_dfl;
				}
				myfug->mutex->unlock();
				omni_thread::sleep(pausesec,pausenano);	
			}
			
			if (!myfug->abortflag) {
				myfug->mutex->lock();
				if (CurrentSet() < 0) 			
					cnt_err++;
				else
					cnt_err = 0;	
				if (cnt_err > max_cnt_err) {
					pausesec = 1;
					pausenano = 0;
				}
				else {
					pausesec = pausesec_dfl;
					pausenano = pausenano_dfl;
				}
				myfug->mutex->unlock();				
				omni_thread::sleep(pausesec,pausenano);		
			}
	
			if (!myfug->abortflag) {
				myfug->mutex->lock();
				if (VoltageSet() < 0) 			
					cnt_err++;
				else
					cnt_err = 0;	
				if (cnt_err > max_cnt_err) {
					pausesec = 1;
					pausenano = 0;
				}
				else {
					pausesec = pausesec_dfl;
					pausenano = pausenano_dfl;
				}
				myfug->mutex->unlock();			
				omni_thread::sleep(pausesec,pausenano);				
			}		
		
		}
		else {
			if (cnt_err < max_cnt_err) {
				CurrentSet();	
				VoltageSet();
			}		
		}
		
		MaxVoltageDiff(); /* set max diff voltage */
		
	}	
	
}


int fugthread::MaxVoltageDiff(void)
{
	bool diff_set = false;
	double max_tmp_diff = 0;

	/* no errors fro readings */
	if ((myfug->voltage_t.msg[0] == 0) && (myfug->voltageset_t.msg[0] == 0)) {
		myfug->fug_buf[myfug->fug_buf_idx].init_flag = true;
		myfug->fug_buf[myfug->fug_buf_idx].read_voltage = myfug->voltage_t.data;
		myfug->fug_buf[myfug->fug_buf_idx].set_voltage = myfug->voltageset_t.data;
		
		/* all setting must be equal before calculation */
		for (int i = 0; i < myfug->maxDiffLen-1; i++) {
			if (fabs(myfug->fug_buf[i].set_voltage - myfug->fug_buf[i+1].set_voltage) > 0.002) {
				diff_set = true;
				break;
			}
		}
		/* all buffer has to be filled */
		for (int i = 0; i < myfug->maxDiffLen; i++) {
			if (myfug->fug_buf[i].init_flag == false) {
				diff_set = true;
				break;
			}
		}
		
		
		
		/* if all buffer filled with the same setting */
		if (diff_set == false) {
			for (int i = 0; i < myfug->maxDiffLen; i++) {
				if (fabs(myfug->fug_buf[i].set_voltage - myfug->fug_buf[i].read_voltage) > max_tmp_diff) {
					max_tmp_diff = fabs(myfug->fug_buf[i].set_voltage - 
					myfug->fug_buf[i].read_voltage);
				}
			}
			*myfug->attr_MaxDiffVoltage_read = max_tmp_diff;
		}
		else {
			if (*myfug->attr_MaxDiffVoltage_read < 0) 
				*myfug->attr_MaxDiffVoltage_read--;
			else
				*myfug->attr_MaxDiffVoltage_read = -1; /* invalid value */
		}

		myfug->fug_buf_idx++;
		
		if (myfug->fug_buf_idx >= myfug->maxDiffLen)
			myfug->fug_buf_idx = 0;
		
	}
	else {
		if (*myfug->attr_MaxDiffVoltage_read < 0) 
			*myfug->attr_MaxDiffVoltage_read--;
		else
			*myfug->attr_MaxDiffVoltage_read = -1; /* invalid value */
	}
		
	return 0;

}



int fugthread::Voltage(void)
{

	string strout;
	char tmpstr[20];
	
	// request settings from Fug serial controller
	try {
		if (myfug->readback == true)
			myfug->write_Fug("P0");		
		myfug->write_Fug("N0");
		strout = myfug->read_Fug();
	}
	catch(Tango::DevFailed& e) {
		std::string temp;
		temp = e.errors[0].desc;
		strncpy(myfug->voltage_t.msg,temp.c_str(),FUG_MSG_LEN);
		return -1;
	}
	
	if (strout[11] != 'V') {
		memset(tmpstr,0,20);
		strncpy(tmpstr,strout.c_str(),20);
		sprintf(myfug->voltage_t.msg,"Returned not valid string: %s",tmpstr);
		return -1;
	}	
	
	/* because sometimes "+1.2332" becomes ";1.2332" */
	double sign;
	if (strout[0] == '+')
		sign = 1;
	else if (strout [0]== '-')
		sign = -1;
	else {
		memset(tmpstr,0,20);
		strncpy(tmpstr,strout.c_str(),20);		
		sprintf(myfug->voltage_t.msg,"Returned not valid string: %s",tmpstr);
		return -1;
	}			
	myfug->voltage_t.data = strtod(strout.c_str(),nullptr)/1000;
	myfug->voltage_t.msg[0]=0;
	
	gettimeofday(&myfug->voltage_t.time,NULL);

	return 0;
	
} 

int fugthread::Current(void)
{
	string strout;
	char tmpstr[20];
	
	// request settings from Fug serial controller
	try {	
		if (myfug->readback == true)
			myfug->write_Fug("P0");
		myfug->write_Fug("N1");
		strout = myfug->read_Fug();
	}
	catch(Tango::DevFailed& e) {
		std::string temp;
		temp = e.errors[0].desc;
		strncpy(myfug->current_t.msg,temp.c_str(),FUG_MSG_LEN);
		return -1;
	}
	
	if (strout[11] != 'A') {
		memset(tmpstr,0,20);
		strncpy(tmpstr,strout.c_str(),20);	
		sprintf(myfug->current_t.msg,"Returned not valid string: %s",tmpstr);
		return -1;
	}	
	
	/* because sometimes "+1.2332" becomes ";1.2332" */			
	double sign;
	if (strout[0] == '+')
		sign = 1;
	else if (strout[0] == '-')
		sign = -1;
	else {
		memset(tmpstr,0,20);
		strncpy(tmpstr,strout.c_str(),20);		
		sprintf(myfug->current_t.msg,"Returned not valid string: %s",tmpstr);
		return -1;
	}	
			
	//myfug->current_t.data = atof(strout.c_str()+1)*sign;
	myfug->current_t.data = strtod(strout.c_str(),nullptr);
	myfug->current_t.msg[0]=0;

	gettimeofday(&myfug->current_t.time,NULL);
	
	return 0;
	
}

int fugthread::VoltageSet(void)
{
	string strout;
	char tmpstr[20];
	
	if (myfug->readback == true) {
		try {	
			myfug->write_Fug("P1");
			myfug->write_Fug("N0");
			strout = myfug->read_Fug();
		}
		catch(Tango::DevFailed& e) {
			std::string temp;
			temp = e.errors[0].desc;
			strncpy(myfug->voltageset_t.msg,temp.c_str(),FUG_MSG_LEN);
			return -1;
		}		
		
		if (strout[11] != 'V') {
			memset(tmpstr,0,20);
			strncpy(tmpstr,strout.c_str(),20);		
			sprintf(myfug->voltageset_t.msg,"Returned not valid string: %s",tmpstr);
			return -1;
		}	

		/* because sometimes "+1.2332" becomes ";1.2332" */	
		double sign;
		if (strout[0] == '+')
			sign = 1;
		else if (strout[0] == '-')
			sign = -1;
		else {
			memset(tmpstr,0,20);
			strncpy(tmpstr,strout.c_str(),20);		
			sprintf(myfug->voltageset_t.msg,"Returned not valid string: %s",tmpstr);
			return -1;
		}	
		//myfug->voltageset_t.data = (atof(strout.c_str()+1)/1000)*sign;
		myfug->voltageset_t.data = strtod(strout.c_str(),nullptr)/1000;

	}
	else {
		myfug->voltageset_t.data = myfug->tmpvoltset;
	}

	gettimeofday(&myfug->voltageset_t.time,NULL);
	
	myfug->voltageset_t.msg[0]=0;
	
	return 0;	

}

int fugthread::CurrentSet(void)
{
	string strout;
	char tmpstr[20];
	
	if (myfug->readback == true) {
		try {	
			myfug->write_Fug("P1");
			myfug->write_Fug("N1");
			strout = myfug->read_Fug();
		}
		catch(Tango::DevFailed& e) {
			std::string temp;
			temp = e.errors[0].desc;
			strncpy(myfug->currentset_t.msg,temp.c_str(),FUG_MSG_LEN);
			return -1;
		}		
		
		if (strout[11] != 'A') {
			memset(tmpstr,0,20);
			strncpy(tmpstr,strout.c_str(),20);		
			sprintf(myfug->currentset_t.msg,"Returned not valid string: %s",tmpstr);
			return -1;
		}	

		/* because sometimes "+1.2332" becomes ";1.2332" */
		double sign;
		if (strout[0] == '+')
			sign = 1;
		else if (strout[0] == '-')
			sign = -1;
		else {
			memset(tmpstr,0,20);
			strncpy(tmpstr,strout.c_str(),20);		
			sprintf(myfug->currentset_t.msg,"Returned not valid string: %s",tmpstr);
			return -1;
		}	
		//myfug->currentset_t.data = (atof(strout.c_str()+1))*sign;
		myfug->currentset_t.data = strtod(strout.c_str(),nullptr);

	}
	else {
		myfug->currentset_t.data = myfug->tmpcurset;
	}
	
	myfug->currentset_t.msg[0]=0;
	gettimeofday(&myfug->currentset_t.time,NULL);
	
	return 0;	

}

int fugthread::Stat(void)
{
	string strout;
	char tmpstr[20];
	
	try {	
		myfug->write_Fug("N2");
		strout = myfug->read_Fug();
	}
	catch(Tango::DevFailed& e) {
		std::string temp;
		temp = e.errors[0].desc;
		strncpy(myfug->stat_t.msg,temp.c_str(),FUG_MSG_LEN);
		return -1;
	}	
	if ((strout.length() < 7) || (strout[3]-'0' != 0)) {	
		memset(tmpstr,0,20);
		strncpy(tmpstr,strout.c_str(),20);			
		sprintf(myfug->stat_t.msg,"Failed to read fug status, string: %s",tmpstr);
		return -1;
	}

	for (int i=0; i<3; i++) {
		myfug->FugStat[i] = static_cast<Tango::DevBoolean>((strout[i]-'0') == 1);
	}
	
	myfug->FugStat[3] = static_cast<Tango::DevBoolean>(((strout[6]-'0') % 2) == 1);
	myfug->FugStat[4] = static_cast<Tango::DevBoolean>(((strout[6]-'0') / 2) == 1);
	
	myfug->stat_t.msg[0]=0;
	gettimeofday(&myfug->stat_t.time,NULL);
	
	return 0;	

}


} //namespace







