//
// file :         fugthread.h
//
// description :  reading thread class
//
// project :      TANGO Device Server
//
// $Author: giulio $ Giulio Gaio
//
// $Revision: 1.1.1.1 $ 1.0
//
// $Log: fugthread.h,v $
// Revision 1.1.1.1  2014-10-22 10:12:39  giulio
// First cvs release
//
//
// copyleft :   Sincrotrone Trieste S.C.p.A.
//              Strada Statale 14 - km 163,5 in AREA Science Park
//              34012 Basovizza, Trieste ITALY
//


#ifndef FUGTHREAD_H
#define FUGTHREAD_H

#include <omnithread.h>
#include <tango.h>
#include <Fug.h>
namespace Fug_ns
{

class fugthread : public omni_thread 
{	
	private:
		Fug_ns::Fug *myfug;
	public:
		
		/* fugthread::fugthread(): initialize init loop */
		fugthread(Fug_ns::Fug *s){ myfug = s;};
		
		/* fugthread::~fugthread(): object destructor */
		~fugthread() {};
					
	protected:
		/* fugthread::run():	start init loop */
		void run(void *);	
		int Current(void);
		int Voltage(void);		
		int CurrentSet(void);
		int VoltageSet(void);		
		int Stat(void);
		int MaxVoltageDiff(void);
				
};	/* end class fugthread() */
}
#endif

/* EOF */
